<ng-container *transloco="let t; prefix: 'newUser'">
  <eui-page>
    <eui-page-header [label]="t('title')"></eui-page-header>
    <eui-page-content>
      <div class="row d-flex justify-content-center">
        <div class="col-12 col-md-10">
          @if(loading){
            <div class="w-full d-flex row items-center justify-content-center py-2">
              <eui-progress-bar isIndeterminate=""></eui-progress-bar>
            </div>
          } @else {
            <form [formGroup]="userForm" id="userForm" (ngSubmit)="onSubmit()" class="d-flex flex-column gap-2">
              <div euiInputGroup>
                <label euiLabel euiRequired="" for="email">{{ t('email') }}</label>
                <input euiInputText id="email" formControlName="email" required
                  placeholder="{{t('emailPlaceholder')}}" />
                  @if (userForm.get('email')?.invalid && (userForm.get('email')?.dirty ||
                  userForm.get('email')?.touched)) {
                    <eui-feedback-message euiDanger>{{ t('emailValidation') }}</eui-feedback-message>
                  }
              </div>
              <div euiInputGroup>
                <label euiLabel euiRequired="" for="firstName">{{ t('firstName') }}</label>
                <input euiInputText id="firstName" formControlName="firstName" required
                  placeholder="{{t('firstNamePlaceholder')}}" />
                  @if (userForm.get('firstName')?.invalid && (userForm.get('firstName')?.dirty ||
                  userForm.get('firstName')?.touched)) {
                    <eui-feedback-message euiDanger>{{ t('required') }}</eui-feedback-message>
                  }
              </div>
              <div euiInputGroup>
                <label euiLabel euiRequired="" for="lastName">{{ t('lastName') }}</label>
                <input euiInputText id="lastName" formControlName="lastName" required
                  placeholder="{{t('lastNamePlaceholder')}}" />
                  @if (userForm.get('lastName')?.invalid && (userForm.get('lastName')?.dirty ||
                  userForm.get('lastName')?.touched)) {
                    <eui-feedback-message euiDanger>{{ t('required') }}</eui-feedback-message>
                  }
              </div>
              <div euiInputGroup>
                <label euiLabel euiRequired="" for="username">{{ t('username') }}</label>
                <input euiInputText id="username" formControlName="username" required
                  placeholder="{{t('usernamePlaceholder')}}" />
                  @if (userForm.get('username')?.invalid && (userForm.get('username')?.dirty ||
                  userForm.get('username')?.touched)) {
                    <eui-feedback-message euiDanger>{{ t('required') }}</eui-feedback-message>
                  }
              </div>

              <div euiInputGroup>
                <label euiLabel euiRequired="" for="password">{{ t('password') }}</label>
                <div euiInputGroupAddOn>
                  <input euiInputText id="password" formControlName="password" required [type]="passwordVisible ? 'text' : 'password'"
                    placeholder="{{t('passwordPlaceholder')}}" />
                    <button euiButton euiSecondary euiOutline euiIconButton (click)="passwordVisible = !passwordVisible" aria-label="Show/Hide">
                      <eui-icon-svg [icon]="passwordVisible ? 'eui-remove' : 'eui-search'" size="s"></eui-icon-svg>
                    </button>
                </div>
                @if (userForm.get('password')?.invalid && (userForm.get('password')?.dirty ||
                  userForm.get('password')?.touched)) {
                    <eui-feedback-message euiDanger>{{ t('required') }}</eui-feedback-message>
                  }
                  <eui-feedback-message>
                    <span class="text-black-50">The password must be between</span>
                    <span
                      [class.text-success]="!userForm.get('password')?.hasError('minLength') && !userForm.get('password')?.hasError('maxLength')"
                      [class.text-danger]="userForm.get('password')?.hasError('minLength') || userForm.get('password')?.hasError('maxLength')">
                      10 and 64 characters long
                    </span>,
                    <span class="text-black-50">and contain at least</span>
                    <span [class.text-success]="!userForm.get('password')?.hasError('uppercase')"
                      [class.text-danger]="userForm.get('password')?.hasError('uppercase')">
                      1 uppercase letter (A-Z)
                    </span>,
                    <span [class.text-success]="!userForm.get('password')?.hasError('lowercase')"
                      [class.text-danger]="userForm.get('password')?.hasError('lowercase')">
                      1 lowercase letter (a-z)
                    </span>,
                    <span [class.text-success]="!userForm.get('password')?.hasError('numeric')"
                      [class.text-danger]="userForm.get('password')?.hasError('numeric')">
                      1 number (0-9)
                    </span>,
                    <span [class.text-success]="!userForm.get('password')?.hasError('specialChar')"
                      [class.text-danger]="userForm.get('password')?.hasError('specialChar')">
                      1 special character (!£%&&#64; etc).
                    </span>,
                    <span [class.text-success]="!userForm.get('password')?.hasError('forbidden')"
                      [class.text-danger]="userForm.get('password')?.hasError('forbidden')">
                      The password cannot contain portions of Email, First Name, Last Name or Username greater than
                      4 characters.
                    </span>
                  </eui-feedback-message>
              </div>

              <div euiInputGroup>
                <label euiLabel euiRequired="" for="confirmPassword">{{ t('confirmPassword') }}</label>
                <div euiInputGroupAddOn>
                  <input euiInputText id="confirmPassword" formControlName="confirmPassword" required [type]="passwordConfirmVisible ? 'text' : 'password'"
                    placeholder="{{t('confirmPasswordPlaceholder')}}" />
                    <button euiButton euiSecondary euiOutline euiIconButton (click)="passwordConfirmVisible = !passwordConfirmVisible" aria-label="Show/Hide">
                      <eui-icon-svg [icon]="passwordConfirmVisible ? 'eui-remove' : 'eui-search'" size="s"></eui-icon-svg>
                    </button>
                </div>
                @if (userForm.get('confirmPassword')!.hasError('noMatch')) {
                  <eui-feedback-message euiDanger>{{ t('noMatch') }}</eui-feedback-message>
                }
              </div>

              <div euiInputGroup>
                <label euiLabel for="roles">{{ t('rolesPlaceholder') }}</label>
                <eui-autocomplete id="roles" formControlName="roles" [autocompleteData]="selectableRoles"
                    [hasChips]="true">
                </eui-autocomplete>
              </div>

              <div>
                <button euiButton id="submitButton" [disabled]="loading || !userForm.valid" type="submit" class="eui-u-mr-s eui-u-mb-s" euiPrimary>
                  @if(loading){
                    <eui-icon-svg isLoading></eui-icon-svg>
                  }
                  <span euiLabel class="eui-u-ml-s">{{ t('button') }}</span>
                </button>
              </div>
            </form>
          }
        </div>
      </div>
    </eui-page-content>
  </eui-page>
